"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var classnames_1 = __importDefault(require("classnames"));
var react_core_1 = require("@patternfly/react-core");
require("./bulk-select.css");
var BulkSelect = function (_a) {
    var id = _a.id, _b = _a.isDisabled, isDisabled = _b === void 0 ? false : _b, _c = _a.items, items = _c === void 0 ? [] : _c, onSelect = _a.onSelect, _d = _a.checked, checked = _d === void 0 ? false : _d, toggleProps = _a.toggleProps, count = _a.count, className = _a.className, _e = _a.ouiaSafe, ouiaSafe = _e === void 0 ? true : _e, props = __rest(_a, ["id", "isDisabled", "items", "onSelect", "checked", "toggleProps", "count", "className", "ouiaSafe"]);
    var _f = (0, react_1.useState)(false), isOpen = _f[0], setIsOpen = _f[1];
    var hasError = (0, react_1.useRef)(false).current;
    var onToggle = function (isOpen) { return setIsOpen(isOpen); };
    var dropdownOuiaId = props.dropdownOuiaId, checkboxOuiaId = props.checkboxOuiaId, listOuiaId = props.listOuiaId;
    return ((0, jsx_runtime_1.jsx)(react_1.Fragment, { children: items && items.length > 0 ? ((0, jsx_runtime_1.jsx)(react_core_1.Dropdown, __assign({ onSelect: function () { return onToggle(false); }, onOpenChange: function (isOpen) { return setIsOpen(isOpen); }, ouiaId: dropdownOuiaId !== null && dropdownOuiaId !== void 0 ? dropdownOuiaId : 'BulkSelect' }, props, { className: (0, classnames_1.default)(className, 'ins-c-bulk-select'), ouiaSafe: ouiaSafe, toggle: function (toggleRef) { return ((0, jsx_runtime_1.jsx)(react_core_1.MenuToggle, __assign({}, toggleProps, { isDisabled: isDisabled, isExpanded: isOpen, ref: toggleRef, onClick: function () { return setIsOpen(function (prev) { return !prev; }); }, ouiaId: dropdownOuiaId !== null && dropdownOuiaId !== void 0 ? dropdownOuiaId : 'BulkSelect', children: (toggleProps === null || toggleProps === void 0 ? void 0 : toggleProps.children) ? (toggleProps === null || toggleProps === void 0 ? void 0 : toggleProps.children) : ((0, jsx_runtime_1.jsx)(react_1.Fragment, { children: (0, jsx_runtime_1.jsx)(react_core_1.MenuToggleCheckbox, { id: id ? "".concat(id, "-toggle-checkbox") : 'toggle-checkbox', "aria-label": "Select all", onChange: function (checked, event) {
                            setIsOpen(false);
                            onSelect === null || onSelect === void 0 ? void 0 : onSelect(checked, event);
                        }, isChecked: checked, ouiaId: checkboxOuiaId !== null && checkboxOuiaId !== void 0 ? checkboxOuiaId : 'BulkSelectCheckbox', children: !hasError && count ? "".concat(count, " selected") : '' }) }, "split-checkbox")) }))); }, isOpen: isOpen, popperProps: { appendTo: 'inline' }, children: (0, jsx_runtime_1.jsxs)(react_core_1.DropdownList, { "data-ouia-component-id": listOuiaId !== null && listOuiaId !== void 0 ? listOuiaId : 'BulkSelectList', children: [count !== undefined && count > 0 && ((0, jsx_runtime_1.jsx)(react_core_1.DropdownItem, { isDisabled: true, className: (0, classnames_1.default)({
                            'ins-c-bulk-select__selected': !hasError,
                        }), children: "MenuItemected" }, "count")), items.map(function (oneItem, key) { return ((0, jsx_runtime_1.jsx)(react_core_1.DropdownItem, __assign({ component: "button", ouiaId: "".concat(listOuiaId !== null && listOuiaId !== void 0 ? listOuiaId : 'BulkSelectList', "-").concat(oneItem.key || key), onClick: function (event) { return oneItem.onClick && oneItem.onClick(event, oneItem, key); } }, oneItem === null || oneItem === void 0 ? void 0 : oneItem.props, { children: oneItem.title }), oneItem.key || key)); })] }) }))) : ((0, jsx_runtime_1.jsx)(react_core_1.Checkbox, __assign({}, props, { "aria-label": "Select all", className: (0, classnames_1.default)(className, 'ins-c-bulk-select'), id: "".concat(id, "-checkbox"), isChecked: checked, onChange: function (e, checked) { return onSelect === null || onSelect === void 0 ? void 0 : onSelect(checked, e); }, ouiaId: dropdownOuiaId !== null && dropdownOuiaId !== void 0 ? dropdownOuiaId : 'BulkSelect' }))) }));
};
exports.default = BulkSelect;
//# sourceMappingURL=BulkSelect.js.map