"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var classnames_1 = __importDefault(require("classnames"));
var t_global_breakpoint_md_1 = __importDefault(require("@patternfly/react-tokens/dist/js/t_global_breakpoint_md"));
var Dropdown_1 = require("@patternfly/react-core/dist/dynamic/components/Dropdown");
var Dropdown_2 = require("@patternfly/react-core/dist/dynamic/components/Dropdown");
var Dropdown_3 = require("@patternfly/react-core/dist/dynamic/components/Dropdown");
var Icon_1 = require("@patternfly/react-core/dist/dynamic/components/Icon");
var MenuToggle_1 = require("@patternfly/react-core/dist/dynamic/components/MenuToggle");
var Split_1 = require("@patternfly/react-core/dist/dynamic/layouts/Split");
var Split_2 = require("@patternfly/react-core/dist/dynamic/layouts/Split");
var Toolbar_1 = require("@patternfly/react-core/dist/dynamic/components/Toolbar");
var Toolbar_2 = require("@patternfly/react-core/dist/dynamic/components/Toolbar");
var Toolbar_3 = require("@patternfly/react-core/dist/dynamic/components/Toolbar");
var filter_icon_1 = __importDefault(require("@patternfly/react-icons/dist/dynamic/icons/filter-icon"));
var TextFilter_1 = __importDefault(require("./TextFilter"));
var conditionalFilterConstants_1 = require("./conditionalFilterConstants");
var RadioFilter_1 = __importDefault(require("./RadioFilter"));
var CheckboxFilter_1 = __importDefault(require("./CheckboxFilter"));
var GroupFilter_1 = __importDefault(require("./GroupFilter"));
require("./conditional-filter.css");
var SingleSelectFilter_1 = __importDefault(require("./SingleSelectFilter"));
var ConditionalFilter = function (_a) {
    var _b = _a.hideLabel, hideLabel = _b === void 0 ? false : _b, _c = _a.id, id = _c === void 0 ? 'default-input' : _c, _d = _a.isDisabled, isDisabled = _d === void 0 ? false : _d, _f = _a.items, items = _f === void 0 ? [] : _f, onChange = _a.onChange, placeholder = _a.placeholder, _g = _a.value, value = _g === void 0 ? '' : _g, innerRef = _a.innerRef;
    var breakpointConstant = parseInt(t_global_breakpoint_md_1.default.value.replace('px', ''));
    var updateFilterViewport = function (width) { return width <= breakpointConstant; };
    var _h = (0, react_1.useState)(false), isOpen = _h[0], setIsOpen = _h[1];
    var _j = (0, react_1.useState)(), stateValue = _j[0], setStateValue = _j[1];
    var _k = (0, react_1.useState)(updateFilterViewport(window.innerWidth)), isMobile = _k[0], setIsMobile = _k[1];
    var resizeListener = (0, react_1.useRef)(function (event) {
        setIsMobile(updateFilterViewport((event === null || event === void 0 ? void 0 : event.target).innerWidth));
    });
    (0, react_1.useEffect)(function () {
        window.addEventListener('resize', resizeListener.current);
        return function () {
            resizeListener.current && window.removeEventListener('resize', resizeListener.current);
        };
    }, []);
    var currentValue = onChange ? value : stateValue;
    var activeItem = items && items.length && (items.find(function (item, key) { return item.value === currentValue || key === Number(currentValue); }) || items[0]);
    var onChangeDefault = function (_e, value) { return setStateValue(value); };
    var onChangeCallback = onChange || onChangeDefault;
    var capitalize = function (string) { return string[0].toUpperCase() + string.substring(1); };
    var Wrapper = isMobile
        ? function (props) { return ((0, jsx_runtime_1.jsx)(Toolbar_3.ToolbarToggleGroup, __assign({}, props, { breakpoint: "md", toggleIcon: (0, jsx_runtime_1.jsx)(Icon_1.Icon, { size: "md", children: (0, jsx_runtime_1.jsx)(filter_icon_1.default, {}) }) }))); }
        : react_1.Fragment;
    var getActiveComponent = function (activeItem) {
        if (activeItem.type === 'checkbox' && (0, conditionalFilterConstants_1.identifyComponent)(activeItem.type, activeItem.filterValues)) {
            return (0, jsx_runtime_1.jsx)(CheckboxFilter_1.default, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues));
        }
        else if (activeItem.type === 'text' && (0, conditionalFilterConstants_1.identifyComponent)(activeItem.type, activeItem.filterValues)) {
            return (0, jsx_runtime_1.jsx)(TextFilter_1.default, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues));
        }
        else if (activeItem.type === 'group' && (0, conditionalFilterConstants_1.identifyComponent)(activeItem.type, activeItem.filterValues)) {
            return (0, jsx_runtime_1.jsx)(GroupFilter_1.default, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues));
        }
        else if (activeItem.type === 'radio' && (0, conditionalFilterConstants_1.identifyComponent)(activeItem.type, activeItem.filterValues)) {
            return ((0, jsx_runtime_1.jsx)(RadioFilter_1.default, __assign({ innerRef: innerRef, placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues)));
        }
        else if (activeItem.type === 'singleSelect' && (0, conditionalFilterConstants_1.identifyComponent)(activeItem.type, activeItem.filterValues)) {
            return ((0, jsx_runtime_1.jsx)(SingleSelectFilter_1.default, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues)));
        }
        else if (activeItem.type === 'custom' && (0, conditionalFilterConstants_1.identifyComponent)(activeItem.type, activeItem.filterValues)) {
            var C = conditionalFilterConstants_1.typeMapper.custom;
            var _a = activeItem.filterValues, key = _a.key, children = _a.children;
            return (0, jsx_runtime_1.jsx)(C, { children: children }, key);
        }
        else {
            throw new Error("Invalid conditional filter component type! Expected one of ".concat(Object.keys(conditionalFilterConstants_1.conditionalFilterType), ", got ").concat(activeItem.type, "."));
        }
    };
    var ActiveComponent = activeItem && (conditionalFilterConstants_1.typeMapper[activeItem.type] || conditionalFilterConstants_1.typeMapper.text);
    return ((0, jsx_runtime_1.jsxs)(Wrapper, { children: [isMobile && ((0, jsx_runtime_1.jsx)(Toolbar_1.ToolbarGroup, { className: "ins-c-conditional-filter mobile", children: items.map(function (activeItem, key) { return ((0, jsx_runtime_1.jsx)(Toolbar_2.ToolbarItem, { children: getActiveComponent(activeItem) }, key)); }) })), !isMobile && ((0, jsx_runtime_1.jsx)(react_1.Fragment, { children: !items || (items && items.length <= 0) ? ((0, jsx_runtime_1.jsx)("div", { className: (0, classnames_1.default)('ins-c-conditional-filter', {
                        desktop: isMobile,
                    }), children: (0, jsx_runtime_1.jsx)(TextFilter_1.default, { innerRef: innerRef, id: id, isDisabled: isDisabled, onChange: function (e) { return onChangeCallback(e, e.target.value); }, placeholder: placeholder, value: currentValue ? String(currentValue) : undefined, "widget-type": "InsightsInput" }) })) : ((0, jsx_runtime_1.jsxs)(Split_1.Split, { className: (0, classnames_1.default)('ins-c-conditional-filter', {
                        desktop: isMobile,
                    }), children: [items.length > 1 && ((0, jsx_runtime_1.jsx)(Split_2.SplitItem, { children: (0, jsx_runtime_1.jsx)(Dropdown_1.Dropdown, { ref: innerRef, onSelect: function () { return setIsOpen(false); }, isOpen: isOpen, ouiaId: "ConditionalFilterList", onOpenChange: function (isOpen) { return setIsOpen(isOpen); }, toggle: function (toggleRef) { return ((0, jsx_runtime_1.jsxs)(MenuToggle_1.MenuToggle, { isDisabled: isDisabled, className: hideLabel ? 'ins-c-conditional-filter__group ins-c-conditional-filter__no-label' : 'ins-c-conditional-filter__group', "aria-label": "Conditional filter toggle", ref: toggleRef, onClick: function () { return setIsOpen(function (prev) { return !prev; }); }, isExpanded: isOpen, ouiaId: "ConditionalFilterToggle", children: [(0, jsx_runtime_1.jsx)(Icon_1.Icon, { size: "md", children: (0, jsx_runtime_1.jsx)(filter_icon_1.default, {}) }), !hideLabel && ((0, jsx_runtime_1.jsx)("span", { className: "ins-c-conditional-filter__value-selector", children: activeItem && capitalize(String(activeItem.label)) }))] })); }, children: (0, jsx_runtime_1.jsx)(Dropdown_3.DropdownList, { "aria-label": "Conditional filters list", children: items.map(function (item, key) { return ((0, jsx_runtime_1.jsx)(Dropdown_2.DropdownItem, { component: "button", ouiaId: String(item.label), onClick: function (e) { return onChangeCallback(e, item.value || key); }, children: capitalize(String(item.label)) }, item.id ? "".concat(item.id, "-dropdown") : key)); }) }) }) })), ActiveComponent && ((0, jsx_runtime_1.jsx)(Split_2.SplitItem, { isFilled: true, "data-ouia-component-id": "ConditionalFilter", children: getActiveComponent(activeItem) }))] })) }))] }));
};
exports.default = ConditionalFilter;
//# sourceMappingURL=ConditionalFilter.js.map