import React from 'react';
import { FilterMenuItemOnChange, Group, GroupFilterItem } from './groupFilterConstants';
import './group-filter.scss';
import { GroupItem } from './groupFilterConstants';
type FilterableProps = {
    isFilterable: true;
    onFilter: (value: string) => void;
};
export type GroupFilterProps = {
    className?: string;
    filterBy?: string;
    groups?: Group[];
    items?: GroupFilterItem[];
    onChange: FilterMenuItemOnChange;
    onShowMore?: (event: React.MouseEvent | React.KeyboardEvent | MouseEvent) => void;
    placeholder?: string;
    selected?: Record<string, Record<string, GroupItem | boolean>>;
    showMoreTitle?: React.ReactNode;
    showMoreOptions?: Record<string, unknown>;
    isDisabled?: boolean;
} & (FilterableProps | {
    isFilterable?: false;
    onFilter?: undefined;
});
declare const GroupFilter: React.FunctionComponent<GroupFilterProps>;
export default GroupFilter;
