"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var classnames_1 = __importDefault(require("classnames"));
var Button_1 = require("@patternfly/react-core/dist/dynamic/components/Button");
var Checkbox_1 = require("@patternfly/react-core/dist/dynamic/components/Checkbox");
var Menu_1 = require("@patternfly/react-core/dist/dynamic/components/Menu");
var Menu_2 = require("@patternfly/react-core/dist/dynamic/components/Menu");
var MenuToggle_1 = require("@patternfly/react-core/dist/dynamic/components/MenuToggle");
var Popper_1 = require("@patternfly/react-core/dist/dynamic/helpers/Popper/Popper");
var Radio_1 = require("@patternfly/react-core/dist/dynamic/components/Radio");
var TextInputGroup_1 = require("@patternfly/react-core/dist/dynamic/components/TextInputGroup");
var TreeView_1 = require("@patternfly/react-core/dist/dynamic/components/TreeView");
var times_icon_1 = require("@patternfly/react-icons/dist/dynamic/icons/times-icon");
var groupFilterConstants_1 = require("./groupFilterConstants");
var groupType_1 = __importDefault(require("./groupType"));
require("./group-filter.css");
var GroupFilter = function (props) {
    var className = props.className, _a = props.filterBy, filterBy = _a === void 0 ? '' : _a, _b = props.groups, groups = _b === void 0 ? [] : _b, _c = props.items, items = _c === void 0 ? [] : _c, isFilterable = props.isFilterable, onChange = props.onChange, onShowMore = props.onShowMore, placeholder = props.placeholder, selected = props.selected, showMoreTitle = props.showMoreTitle, showMoreOptions = props.showMoreOptions, isDisabled = props.isDisabled, onFilter = props.onFilter;
    var _d = (0, react_1.useState)(''), searchString = _d[0], setSearchString = _d[1];
    var _f = (0, react_1.useState)(false), isOpen = _f[0], setIsOpen = _f[1];
    var toggleRef = (0, react_1.useRef)(null);
    var containerRef = (0, react_1.useRef)(null);
    var menuRef = (0, react_1.useRef)(null);
    var inputRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        setSearchString(filterBy);
    }, [filterBy]);
    var handleMenuKeys = function (event) {
        var _a, _b, _c;
        if (!isOpen) {
            return;
        }
        if (((_a = menuRef.current) === null || _a === void 0 ? void 0 : _a.contains(event.target)) || ((_b = toggleRef.current) === null || _b === void 0 ? void 0 : _b.contains(event.target))) {
            if (event.key === 'Escape' || event.key === 'Enter') {
                setIsOpen(!isOpen);
                (_c = toggleRef.current) === null || _c === void 0 ? void 0 : _c.focus();
            }
        }
    };
    var handleClickOutside = function (event) {
        var _a, _b, _c;
        if (!isOpen)
            return;
        var clickedInsideInput = (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.contains(event.target);
        var clickedInsideMenu = (_b = menuRef.current) === null || _b === void 0 ? void 0 : _b.contains(event.target);
        var clickedToggle = (_c = toggleRef.current) === null || _c === void 0 ? void 0 : _c.contains(event.target);
        if (clickedInsideInput || clickedInsideMenu || clickedToggle)
            return;
        setIsOpen(false);
    };
    (0, react_1.useEffect)(function () {
        window.addEventListener('keydown', handleMenuKeys);
        window.addEventListener('click', handleClickOutside);
        return function () {
            window.removeEventListener('keydown', handleMenuKeys);
            window.removeEventListener('click', handleClickOutside);
        };
    }, [isOpen, menuRef]);
    var onToggleClick = function () {
        setIsOpen(!isOpen);
    };
    var menuItems = (0, groupFilterConstants_1.getMenuItems)((items === null || items === void 0 ? void 0 : items.map(function (item) { return (item.type === groupType_1.default.treeView ? (0, groupFilterConstants_1.convertTreeItem)(item) : item); })) || [], onChange, (0, groupFilterConstants_1.calculateSelected)(selected || {}));
    var groupMenuItems = (0, groupFilterConstants_1.getGroupMenuItems)(groups, onChange, (0, groupFilterConstants_1.calculateSelected)(selected || {}));
    var renderItem = function (_a, key, type, groupKey) {
        var groupSelectable = _a.groupSelectable, item = __rest(_a, ["groupSelectable"]);
        if (groupKey === void 0) { groupKey = ''; }
        return ((0, jsx_runtime_1.jsx)(Menu_2.MenuItem, { itemId: key, className: item === null || item === void 0 ? void 0 : item.className, onClick: (0, groupFilterConstants_1.isCheckboxItem)(type, item)
                ? function (e) {
                    var _a;
                    (_a = item.onClick) === null || _a === void 0 ? void 0 : _a.call(item, e);
                    e.preventDefault();
                }
                : undefined, children: (0, groupFilterConstants_1.isTreeViewItem)(type, item) ? ((0, jsx_runtime_1.jsx)(TreeView_1.TreeView, { data: [(0, groupFilterConstants_1.mapTree)(item, groupKey, selected || {})], onCheck: function (e, value) { return (0, groupFilterConstants_1.onTreeCheck)(e, value, [item]); }, hasCheckboxes: true })) : (0, groupFilterConstants_1.isCheckboxItem)(type, item) ? ((0, jsx_runtime_1.jsx)(Checkbox_1.Checkbox, __assign({}, item, { label: item === null || item === void 0 ? void 0 : item.label, isChecked: (item === null || item === void 0 ? void 0 : item.isChecked) || (0, groupFilterConstants_1.isChecked)(groupKey, (item === null || item === void 0 ? void 0 : item.value) || key, item === null || item === void 0 ? void 0 : item.id, item === null || item === void 0 ? void 0 : item.tagValue, selected || {}) || false, onChange: item.onChange, onClick: item.onClick
                    ? function (e) {
                        var _a;
                        (_a = item.onClick) === null || _a === void 0 ? void 0 : _a.call(item, e);
                        e.stopPropagation();
                    }
                    : undefined, name: (item === null || item === void 0 ? void 0 : item.name) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key), id: (item === null || item === void 0 ? void 0 : item.id) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key) }))) : (0, groupFilterConstants_1.isRadioItem)(type, item) ? ((0, jsx_runtime_1.jsx)(Radio_1.Radio, __assign({}, item, { isChecked: (item === null || item === void 0 ? void 0 : item.isChecked) || (0, groupFilterConstants_1.isChecked)(groupKey, item.value, item === null || item === void 0 ? void 0 : item.id, item === null || item === void 0 ? void 0 : item.tagValue, selected || {}) || false, onChange: item.onChange, value: (item === null || item === void 0 ? void 0 : item.value) || key, name: (item === null || item === void 0 ? void 0 : item.name) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key), label: (item === null || item === void 0 ? void 0 : item.label) || '', id: (item === null || item === void 0 ? void 0 : item.id) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key) }))) : (0, groupFilterConstants_1.isButtonItem)(type, item) ? ((0, jsx_runtime_1.jsx)(Button_1.Button, { id: item.id, className: (0, classnames_1.default)('pf-v6-c-select__option-button', item.className), variant: item.variant, onClick: item.onClick, children: item.label })) : ((item === null || item === void 0 ? void 0 : item.label) || '') }, "".concat(item.value, "-").concat(key, "-item")));
    };
    var renderItems = function (items, type, groupKey) {
        if (groupKey === void 0) { groupKey = ''; }
        return items.map(function (item, key) {
            return (type || item.type) === groupType_1.default.treeView ? ((0, jsx_runtime_1.jsx)("div", { className: "ins-c-tree-view", children: renderItem(item, key, type, groupKey) }, "".concat(item.value, "-").concat(key, "-item"))) : (renderItem(item, key, type, groupKey));
        });
    };
    var hasFocus = document.activeElement === inputRef.current || document.activeElement === toggleRef.current;
    var searchDirty = hasFocus && (searchString === null || searchString === void 0 ? void 0 : searchString.length) > 0;
    var setFilter = function (value) {
        setSearchString(value);
        onFilter === null || onFilter === void 0 ? void 0 : onFilter(value);
    };
    return ((0, jsx_runtime_1.jsx)("div", { ref: containerRef, children: (0, jsx_runtime_1.jsx)(Popper_1.Popper, { appendTo: containerRef.current, trigger: (0, jsx_runtime_1.jsx)(MenuToggle_1.MenuToggle, { "aria-label": "Group filter", innerRef: toggleRef, onClick: onToggleClick, isExpanded: isOpen, className: (0, classnames_1.default)('ins-c-group-menu-toggle', className, {
                    'pf-v6-u-p-0': isFilterable,
                }), isDisabled: isDisabled, variant: isFilterable || onFilter ? 'typeahead' : 'default', children: isFilterable || onFilter ? ((0, jsx_runtime_1.jsxs)(TextInputGroup_1.TextInputGroup, { isDisabled: isDisabled, isPlain: true, children: [(0, jsx_runtime_1.jsx)(TextInputGroup_1.TextInputGroupMain, { autoComplete: "off", innerRef: inputRef, onClick: onToggleClick, onChange: function (_e, value) {
                                setFilter(value);
                            }, "aria-label": "input with dropdown and clear button", placeholder: placeholder, value: searchString, type: "text" }), (0, jsx_runtime_1.jsx)(TextInputGroup_1.TextInputGroupUtilities, { children: searchDirty && ((0, jsx_runtime_1.jsx)(Button_1.Button, { icon: (0, jsx_runtime_1.jsx)(times_icon_1.TimesIcon, { "aria-hidden": true }), variant: "plain", onClick: function () {
                                    setFilter('');
                                    setIsOpen(false);
                                }, "aria-label": "Clear input value" })) })] })) : (placeholder) }), popper: (0, jsx_runtime_1.jsx)(Menu_1.Menu, { ref: menuRef, className: (0, classnames_1.default)('ins-c-menu__scrollable', className, { 'pf-m-expanded': isOpen }), children: (0, jsx_runtime_1.jsx)(Menu_2.MenuContent, { children: (0, jsx_runtime_1.jsxs)(Menu_2.MenuList, { "aria-label": "Group filter", children: [menuItems.length > 0 && (0, jsx_runtime_1.jsx)(Menu_2.MenuGroup, { children: renderItems(menuItems) }), groupMenuItems.map(function (group, groupKey) { return ((0, jsx_runtime_1.jsx)(Menu_2.MenuGroup, { label: !group.groupSelectable && typeof group.label === 'string' ? group.label : undefined, children: group.items && renderItems(group.items, group.type, group.value) }, "".concat(group.label, "-").concat(groupKey, "-group"))); }), onShowMore ? ((0, jsx_runtime_1.jsx)(Menu_2.MenuItem, __assign({ itemId: "loader", className: "ins-c-menu__show--more" }, showMoreOptions, { onClick: function (e) { return onShowMore(e); }, children: showMoreTitle }))) : ((0, jsx_runtime_1.jsx)("span", { hidden: true, value: "" }))] }) }) }), isVisible: isOpen }) }));
};
exports.default = GroupFilter;
//# sourceMappingURL=GroupFilter.js.map