import React, { FormEvent, MouseEventHandler, ReactNode } from 'react';
import { TextInputProps } from '@patternfly/react-core/dist/dynamic/components/TextInput';
import './conditional-filter.scss';
export declare function isFilterValue(item: undefined | string | number | boolean | FilterValue | Record<string, any>): item is FilterValue;
export interface FilterItem {
    label: ReactNode;
    name?: string;
    value: string;
    id?: string;
    onChange?: (e: FormEvent, item: FilterItem, key: number) => void;
    onClick?: (e?: FormEvent | MouseEventHandler<HTMLInputElement>, item?: FilterItem, key?: number, checked?: boolean) => void;
    isChecked?: boolean;
}
export interface FilterValue {
    label: ReactNode;
    value: string | number | boolean;
}
export interface TextFilterProps extends Omit<TextInputProps, 'onChange'> {
    onChange: NonNullable<TextInputProps['onChange']>;
}
declare const TextFilter: React.FunctionComponent<TextFilterProps>;
export default TextFilter;
