import { TextFilterProps } from './TextFilter';
import { CheckboxFilterProps } from './CheckboxFilter';
import { RadioFilterProps } from './RadioFilter';
import { GroupFilterProps } from './GroupFilter';
import { SingleSelectFilterProps } from './SingleSelectFilter';
export declare const conditionalFilterType: {
    text: string;
    checkbox: string;
    radio: string;
    custom: string;
    group: string;
    singleSelect: string;
};
export declare const typeMapper: {
    text: import("react").FunctionComponent<TextFilterProps>;
    checkbox: import("react").FunctionComponent<CheckboxFilterProps>;
    radio: import("react").FunctionComponent<RadioFilterProps>;
    custom: import("react").ExoticComponent<{
        children?: import("react").ReactNode | undefined;
    }>;
    group: import("react").FunctionComponent<GroupFilterProps>;
    singleSelect: import("react").FunctionComponent<SingleSelectFilterProps>;
};
export declare function identifyComponent<T extends TextFilterProps | CheckboxFilterProps | RadioFilterProps | GroupFilterProps | SingleSelectFilterProps | Record<string, any>>(type: keyof typeof conditionalFilterType, props: T): props is T;
