"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.actionPropsGenerator = exports.overflowActionsMapper = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var react_2 = __importStar(require("react"));
var react_core_1 = require("@patternfly/react-core");
var ellipsis_v_icon_1 = __importDefault(require("@patternfly/react-icons/dist/dynamic/icons/ellipsis-v-icon"));
var DownloadButton_1 = require("../DownloadButton");
var classnames_1 = __importDefault(require("classnames"));
function isActionObject(node) {
    return node.label !== undefined;
}
var overflowActionsMapper = function (action, key) {
    var internalAction = action;
    return ((0, react_1.createElement)(react_core_1.DropdownItem, __assign({}, internalAction.props, { className: "ins-c-primary-toolbar__overflow-actions", key: internalAction.value || internalAction.key || "".concat(key, "-overflow"), component: (internalAction.props && internalAction.props.component) || react_2.default.isValidElement(internalAction.label || action) ? 'div' : 'button', onClick: function (e) { return internalAction.onClick && internalAction.onClick(e, internalAction, key); } }), internalAction.label || action));
};
exports.overflowActionsMapper = overflowActionsMapper;
var actionPropsGenerator = function (action, key) {
    var _a;
    var onClick = typeof action === 'object' && action !== null && typeof (action === null || action === void 0 ? void 0 : action.onClick) === 'function'
        ? function (e) { return action === null || action === void 0 ? void 0 : action.onClick(e, action, key); }
        : undefined;
    return __assign(__assign({}, action === null || action === void 0 ? void 0 : action.props), { onClick: onClick, component: ((_a = action === null || action === void 0 ? void 0 : action.props) === null || _a === void 0 ? void 0 : _a.component) || (react_2.default.isValidElement(action.label || action) ? 'div' : 'button'), children: (typeof action === 'object' && action !== null ? action === null || action === void 0 ? void 0 : action.label : action) });
};
exports.actionPropsGenerator = actionPropsGenerator;
var Actions = function (_a) {
    var _b;
    var _c = _a.actions, actions = _c === void 0 ? [] : _c, _d = _a.overflowActions, overflowActions = _d === void 0 ? [] : _d, _e = _a.onSelect, onSelect = _e === void 0 ? function () { return undefined; } : _e, _f = _a.dropdownProps, dropdownProps = _f === void 0 ? {} : _f, exportConfig = _a.exportConfig;
    var _g = (0, react_2.useState)(false), isOpen = _g[0], setIsOpen = _g[1];
    var toggleOpen = function (isOpen) { return setIsOpen(isOpen); };
    var firstAction = actions[0], restActions = actions.slice(1);
    var dropdownItems = __spreadArray(__spreadArray(__spreadArray(__spreadArray([], (firstAction
        ? [
            (0, jsx_runtime_1.jsx)(react_core_1.DropdownItem, __assign({}, (0, exports.actionPropsGenerator)(firstAction, 'first-action'), { className: (0, classnames_1.default)('ins-c-primary-toolbar__first-action', isActionObject(firstAction) ? (_b = firstAction === null || firstAction === void 0 ? void 0 : firstAction.props) === null || _b === void 0 ? void 0 : _b.className : undefined) }), "first-action"),
        ]
        : []), true), restActions.map(function (action, key) {
        var _a;
        return ((0, jsx_runtime_1.jsx)(react_core_1.DropdownItem, __assign({}, (0, exports.actionPropsGenerator)(action, key)), (action === null || action === void 0 ? void 0 : action.key) || ((_a = action === null || action === void 0 ? void 0 : action.props) === null || _a === void 0 ? void 0 : _a.key) || key));
    }), true), (actions.length > 0 && overflowActions.length > 0
        ? [(0, jsx_runtime_1.jsx)(react_core_1.Divider, { className: "ins-c-primary-toolbar__overflow-actions-separator" }, "separator")]
        : []), true), overflowActions.map(function (action, key) { return (0, exports.overflowActionsMapper)(action, key); }), true);
    return ((0, jsx_runtime_1.jsxs)(react_2.Fragment, { children: [firstAction && ((0, jsx_runtime_1.jsx)(react_core_1.ToolbarItem, { className: "ins-c-primary-toolbar__first-action pf-m-spacer-sm", children: isActionObject(firstAction) ? ((0, jsx_runtime_1.jsx)(react_core_1.Button, __assign({ ouiaId: "".concat(firstAction.label) }, firstAction.props, { onClick: firstAction.onClick || (firstAction.props && firstAction.props.onClick) || undefined, children: firstAction.label }))) : (firstAction) })), exportConfig && (exportConfig.extraItems || exportConfig.onSelect) && ((0, jsx_runtime_1.jsx)(react_core_1.ToolbarItem, { className: "pf-m-spacer-sm", children: (0, jsx_runtime_1.jsx)(DownloadButton_1.DownloadButton, __assign({}, exportConfig)) })), ((actions === null || actions === void 0 ? void 0 : actions.length) > 0 || overflowActions.length > 0) && ((0, jsx_runtime_1.jsx)(react_core_1.ToolbarItem, { className: "".concat(actions.length <= 1 ? 'ins-m-actions--empty' : '', " ins-c-primary-toolbar__actions pf-m-spacer-sm"), children: (0, jsx_runtime_1.jsx)(react_core_1.Dropdown, __assign({}, dropdownProps, { isOpen: isOpen, onSelect: function () {
                        var props = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            props[_i] = arguments[_i];
                        }
                        onSelect === null || onSelect === void 0 ? void 0 : onSelect.apply(void 0, props);
                        toggleOpen(false);
                    }, onOpenChange: setIsOpen, ouiaId: "BulkActionsList", toggle: function (toggleRef) { return ((0, jsx_runtime_1.jsx)(react_core_1.MenuToggle, { ref: toggleRef, "aria-label": "kebab dropdown toggle", variant: "plain", onClick: function () { return setIsOpen(function (prev) { return !prev; }); }, isExpanded: isOpen, ouiaId: "BulkActionsToggle", icon: (0, jsx_runtime_1.jsx)(ellipsis_v_icon_1.default, {}) })); }, popperProps: { appendTo: 'inline' }, children: (0, jsx_runtime_1.jsx)(react_core_1.DropdownList, { children: dropdownItems }) })) }))] }));
};
exports.default = Actions;
//# sourceMappingURL=Actions.js.map