"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var Tooltip_1 = require("@patternfly/react-core/dist/dynamic/components/Tooltip");
var classnames_1 = __importDefault(require("classnames"));
require("./severity-line.css");
var chartMapper = function (width) { return ({
    1: '1',
    2: width / 3,
    3: width * (2 / 3),
    4: width - 1,
}); };
var defaultConfig = {
    height: 12,
    width: 302,
};
var SeverityLine = function (_a) {
    var title = _a.title, value = _a.value, className = _a.className, tooltipMessage = _a.tooltipMessage, _b = _a.config, config = _b === void 0 ? defaultConfig : _b, chartProps = _a.chartProps;
    var _c = __assign(__assign({}, defaultConfig), config), width = _c.width, height = _c.height;
    var severity = (0, react_1.useMemo)(function () {
        var _a;
        return (_a = chartMapper(width)) === null || _a === void 0 ? void 0 : _a[value];
    }, [width, value]);
    var chartClasses = (0, classnames_1.default)(className, 'ins-c-severity-line');
    var points = [
        { className: 'horizontal', points: "".concat(1, ", ").concat(height / 2, " ").concat(width - 1, ", ").concat(height / 2) },
        { className: 'vertical', points: "".concat(width - 1, ", ").concat(0, " ").concat(width - 1, ", ").concat(height) },
        { className: 'vertical', points: "".concat(width * (2 / 3), ", ").concat(0, " ").concat(width * (2 / 3), ", ").concat(height) },
        { className: 'vertical', points: "".concat(width / 3, ", ").concat(0, " ").concat(width / 3, ", ").concat(height) },
        { className: 'vertical', points: "".concat(1, ", ").concat(0, " ").concat(1, ", ").concat(height) },
        { className: "dataline-".concat(value), points: "".concat(1, ", ").concat(height / 2, " ").concat(severity, ", ").concat(height / 2) },
    ];
    return ((0, jsx_runtime_1.jsxs)("div", __assign({ className: chartClasses }, chartProps, { children: [(0, jsx_runtime_1.jsx)("div", { className: "ins-l-title", children: title.length > 14 ? ((0, jsx_runtime_1.jsx)(Tooltip_1.Tooltip, { content: title, children: (0, jsx_runtime_1.jsxs)("span", { children: [" ", "".concat(title.substring(0, 14), "..."), " "] }) })) : ((0, jsx_runtime_1.jsxs)("span", { children: [" ", title, " "] })) }), severity && ((0, jsx_runtime_1.jsx)("div", { className: "ins-l-chart", children: (0, jsx_runtime_1.jsxs)("svg", { height: height, width: width, viewBox: "0 0 ".concat(width, " ").concat(height), children: [points.map(function (_a, key) {
                            var className = _a.className, points = _a.points;
                            return ((0, jsx_runtime_1.jsx)("polyline", { className: className, points: points }, key));
                        }), tooltipMessage ? ((0, jsx_runtime_1.jsx)(Tooltip_1.Tooltip, { content: tooltipMessage, children: (0, jsx_runtime_1.jsx)("circle", { className: "dataline-".concat(value), cx: "".concat(severity), cy: "".concat(height / 2), r: "".concat(2) }) })) : ((0, jsx_runtime_1.jsx)("circle", { className: "dataline-".concat(value), cx: "".concat(severity), cy: "".concat(height / 2), r: "".concat(2) }))] }) }))] })));
};
exports.default = SeverityLine;
//# sourceMappingURL=SeverityLine.js.map