import React from 'react';
import './simple-table-filter.scss';
export type SimpleFilterOptionItem = {
    value: string;
    title: string;
};
export type SimpleFilterOption = {
    title: string;
    items: SimpleFilterOptionItem[];
};
export interface SimpleFilterProps extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement> {
    buttonTitle?: string;
    placeholder?: string;
    className?: string;
    options?: SimpleFilterOption;
    onButtonClick?: (activeFilter: string, selected?: SimpleFilterOptionItem) => void;
    onFilterChange: (value: string, selected?: SimpleFilterOptionItem) => void;
    onOptionSelect?: (event: MouseEvent | React.MouseEvent<any, MouseEvent> | React.KeyboardEvent<Element>, oneItem: SimpleFilterOptionItem) => void;
    searchIcon?: boolean;
}
declare const SimpleFilter: React.FC<SimpleFilterProps>;
export default SimpleFilter;
