import React from 'react';
import { ModalProps } from '@patternfly/react-core/dist/dynamic/components/Modal';
import { TableProps } from '@patternfly/react-table/deprecated';
import { PrimaryToolbarProps } from '../PrimaryToolbar';
import { BulkSelectProps } from '../BulkSelect';
import { ConditionalFilterItem } from '../ConditionalFilter';
import { ICell, IRow } from '@patternfly/react-table';
export type TableWithFilterPagination = {
    count: number;
    page: number;
    perPage: number;
};
export interface TableWithFilterProps extends Omit<Partial<ModalProps>, 'rows' | 'onSelect' | 'selected' | 'ref'> {
    rows?: IRow[];
    onSelect?: (selected?: IRow[]) => void;
    selected?: IRow[];
    onUpdateData: (pagination: TableWithFilterPagination) => number | undefined;
    pagination: TableWithFilterPagination;
    loaded?: boolean;
    calculateChecked?: (rows: IRow[], selected: IRow[]) => boolean | null;
    unique?: (rows: IRow[]) => IRow[];
    filters?: ConditionalFilterItem[];
    primaryToolbarProps?: PrimaryToolbarProps;
    title?: string;
    systemName?: string;
    columns?: (string | ICell)[];
    tableProps?: Omit<TableProps, 'rows' | 'cells'>;
    entityName?: string;
    bulkSelect?: BulkSelectProps;
}
declare const TableWithFilter: React.FC<TableWithFilterProps>;
export default TableWithFilter;
