import React, { Component } from 'react';
import './tagModal.scss';
import { TableWithFilterPagination, TableWithFilterProps } from './TableWithFilter';
import { ICell, IRow } from '@patternfly/react-table';
import { ConditionalFilterItem } from '../ConditionalFilter';
import { BulkSelectProps } from '../BulkSelect';
export type OnSelectRow = (selected?: IRow[]) => void;
export type OnUpdateData = (pagination: TableWithFilterPagination) => number | undefined;
export interface TagModalProps extends Omit<TableWithFilterProps, 'onSelect' | 'columns' | 'pagination' | 'loaded' | 'filters' | 'onUpdateData' | 'bulkSelect'> {
    title: string;
    systemName?: string;
    className?: string;
    toggleModal: (e?: React.MouseEventHandler<HTMLButtonElement> | React.MouseEvent<HTMLButtonElement, MouseEvent>, open?: boolean) => void;
    isOpen: boolean;
    tabNames?: string[];
    onApply?: (...args: unknown[]) => void;
    rows: IRow[] | IRow[][];
    columns: (string | ICell)[] | (string | ICell)[][];
    pagination: TableWithFilterPagination | TableWithFilterPagination[];
    loaded: boolean | boolean[];
    filters?: ConditionalFilterItem[][] | ConditionalFilterItem[];
    selected?: IRow[] | IRow[][];
    onSelect?: OnSelectRow | OnSelectRow[];
    onUpdateData?: OnUpdateData | OnUpdateData[];
    bulkSelect?: BulkSelectProps | BulkSelectProps[];
}
declare class TagModal extends Component<TagModalProps, {
    selectedTab: number;
    activeTabKey?: string | number | undefined;
}> {
    state: {
        selectedTab: number;
        activeTabKey: undefined;
    };
    handleTabClick: (_event: React.MouseEvent<HTMLElement, MouseEvent>, tabIndex: string | number) => void;
    renderTable: (rows: IRow[], columns: (string | ICell)[], pagination: TableWithFilterPagination, loaded: boolean, filters: ConditionalFilterItem[], selected: IRow[], onSelect?: (selected?: IRow[] | undefined) => void, onUpdateData?: (pagination: TableWithFilterPagination) => number | undefined, bulkSelect?: BulkSelectProps) => import("react/jsx-runtime").JSX.Element;
    render(): import("react/jsx-runtime").JSX.Element;
}
export default TagModal;
