import React from 'react';
import { DropdownItemProps, MenuToggleCheckboxProps, MenuToggleProps } from '@patternfly/react-core';
import './bulk-select.scss';
export type BulkSelectItem = {
    key?: string | number;
    title?: string;
    props?: DropdownItemProps;
    onClick?: (event: MouseEvent | React.MouseEvent<any, MouseEvent> | React.KeyboardEvent<Element>, oneItem: BulkSelectItem, key: string | number) => void;
};
export interface BulkSelectProps {
    count?: number;
    className?: string;
    items?: BulkSelectItem[];
    checked?: boolean | null;
    id?: string;
    onSelect?: MenuToggleCheckboxProps['onChange'];
    toggleProps?: MenuToggleProps;
    isDisabled?: boolean;
    ouiaSafe?: boolean;
    dropdownOuiaId?: string;
    checkboxOuiaId?: string;
    listOuiaId?: string;
}
declare const BulkSelect: React.FunctionComponent<BulkSelectProps>;
export default BulkSelect;
