var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment, useEffect, useRef, useState } from 'react';
import classNames from 'classnames';
import t_global_breakpoint_md from '@patternfly/react-tokens/dist/js/t_global_breakpoint_md';
import { Dropdown } from '@patternfly/react-core/dist/dynamic/components/Dropdown';
import { DropdownItem } from '@patternfly/react-core/dist/dynamic/components/Dropdown';
import { DropdownList } from '@patternfly/react-core/dist/dynamic/components/Dropdown';
import { Icon } from '@patternfly/react-core/dist/dynamic/components/Icon';
import { MenuToggle } from '@patternfly/react-core/dist/dynamic/components/MenuToggle';
import { Split } from '@patternfly/react-core/dist/dynamic/layouts/Split';
import { SplitItem } from '@patternfly/react-core/dist/dynamic/layouts/Split';
import { ToolbarGroup } from '@patternfly/react-core/dist/dynamic/components/Toolbar';
import { ToolbarItem } from '@patternfly/react-core/dist/dynamic/components/Toolbar';
import { ToolbarToggleGroup } from '@patternfly/react-core/dist/dynamic/components/Toolbar';
import FilterIcon from '@patternfly/react-icons/dist/dynamic/icons/filter-icon';
import TextFilter from './TextFilter';
import { conditionalFilterType, identifyComponent, typeMapper } from './conditionalFilterConstants';
import RadioFilter from './RadioFilter';
import CheckboxFilter from './CheckboxFilter';
import GroupFilter from './GroupFilter';
import '../ConditionalFilter/conditional-filter.css';
import SingleSelectFilter from './SingleSelectFilter';
var ConditionalFilter = function (_a) {
    var _b = _a.hideLabel, hideLabel = _b === void 0 ? false : _b, _c = _a.id, id = _c === void 0 ? 'default-input' : _c, _d = _a.isDisabled, isDisabled = _d === void 0 ? false : _d, _f = _a.items, items = _f === void 0 ? [] : _f, onChange = _a.onChange, placeholder = _a.placeholder, _g = _a.value, value = _g === void 0 ? '' : _g, innerRef = _a.innerRef;
    var breakpointConstant = parseInt(t_global_breakpoint_md.value.replace('px', ''));
    var updateFilterViewport = function (width) { return width <= breakpointConstant; };
    var _h = useState(false), isOpen = _h[0], setIsOpen = _h[1];
    var _j = useState(), stateValue = _j[0], setStateValue = _j[1];
    var _k = useState(updateFilterViewport(window.innerWidth)), isMobile = _k[0], setIsMobile = _k[1];
    var resizeListener = useRef(function (event) {
        setIsMobile(updateFilterViewport((event === null || event === void 0 ? void 0 : event.target).innerWidth));
    });
    useEffect(function () {
        window.addEventListener('resize', resizeListener.current);
        return function () {
            resizeListener.current && window.removeEventListener('resize', resizeListener.current);
        };
    }, []);
    var currentValue = onChange ? value : stateValue;
    var activeItem = items && items.length && (items.find(function (item, key) { return item.value === currentValue || key === Number(currentValue); }) || items[0]);
    var onChangeDefault = function (_e, value) { return setStateValue(value); };
    var onChangeCallback = onChange || onChangeDefault;
    var capitalize = function (string) { return string[0].toUpperCase() + string.substring(1); };
    var Wrapper = isMobile
        ? function (props) { return (_jsx(ToolbarToggleGroup, __assign({}, props, { breakpoint: "md", toggleIcon: _jsx(Icon, { size: "md", children: _jsx(FilterIcon, {}) }) }))); }
        : Fragment;
    var getActiveComponent = function (activeItem) {
        if (activeItem.type === 'checkbox' && identifyComponent(activeItem.type, activeItem.filterValues)) {
            return _jsx(CheckboxFilter, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues));
        }
        else if (activeItem.type === 'text' && identifyComponent(activeItem.type, activeItem.filterValues)) {
            return _jsx(TextFilter, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues));
        }
        else if (activeItem.type === 'group' && identifyComponent(activeItem.type, activeItem.filterValues)) {
            return _jsx(GroupFilter, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues));
        }
        else if (activeItem.type === 'radio' && identifyComponent(activeItem.type, activeItem.filterValues)) {
            return (_jsx(RadioFilter, __assign({ innerRef: innerRef, placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues)));
        }
        else if (activeItem.type === 'singleSelect' && identifyComponent(activeItem.type, activeItem.filterValues)) {
            return (_jsx(SingleSelectFilter, __assign({ placeholder: placeholder || activeItem.placeholder || "Filter by ".concat(activeItem.label) }, activeItem.filterValues)));
        }
        else if (activeItem.type === 'custom' && identifyComponent(activeItem.type, activeItem.filterValues)) {
            var C = typeMapper.custom;
            var _a = activeItem.filterValues, key = _a.key, children = _a.children;
            return _jsx(C, { children: children }, key);
        }
        else {
            throw new Error("Invalid conditional filter component type! Expected one of ".concat(Object.keys(conditionalFilterType), ", got ").concat(activeItem.type, "."));
        }
    };
    var ActiveComponent = activeItem && (typeMapper[activeItem.type] || typeMapper.text);
    return (_jsxs(Wrapper, { children: [isMobile && (_jsx(ToolbarGroup, { className: "ins-c-conditional-filter mobile", children: items.map(function (activeItem, key) { return (_jsx(ToolbarItem, { children: getActiveComponent(activeItem) }, key)); }) })), !isMobile && (_jsx(Fragment, { children: !items || (items && items.length <= 0) ? (_jsx("div", { className: classNames('ins-c-conditional-filter', {
                        desktop: isMobile,
                    }), children: _jsx(TextFilter, { innerRef: innerRef, id: id, isDisabled: isDisabled, onChange: function (e) { return onChangeCallback(e, e.target.value); }, placeholder: placeholder, value: currentValue ? String(currentValue) : undefined, "widget-type": "InsightsInput" }) })) : (_jsxs(Split, { className: classNames('ins-c-conditional-filter', {
                        desktop: isMobile,
                    }), children: [items.length > 1 && (_jsx(SplitItem, { children: _jsx(Dropdown, { ref: innerRef, onSelect: function () { return setIsOpen(false); }, isOpen: isOpen, ouiaId: "ConditionalFilterList", onOpenChange: function (isOpen) { return setIsOpen(isOpen); }, toggle: function (toggleRef) { return (_jsxs(MenuToggle, { isDisabled: isDisabled, className: hideLabel ? 'ins-c-conditional-filter__group ins-c-conditional-filter__no-label' : 'ins-c-conditional-filter__group', "aria-label": "Conditional filter toggle", ref: toggleRef, onClick: function () { return setIsOpen(function (prev) { return !prev; }); }, isExpanded: isOpen, ouiaId: "ConditionalFilterToggle", children: [_jsx(Icon, { size: "md", children: _jsx(FilterIcon, {}) }), !hideLabel && (_jsx("span", { className: "ins-c-conditional-filter__value-selector", children: activeItem && capitalize(String(activeItem.label)) }))] })); }, children: _jsx(DropdownList, { "aria-label": "Conditional filters list", children: items.map(function (item, key) { return (_jsx(DropdownItem, { component: "button", ouiaId: String(item.label), onClick: function (e) { return onChangeCallback(e, item.value || key); }, children: capitalize(String(item.label)) }, item.id ? "".concat(item.id, "-dropdown") : key)); }) }) }) })), ActiveComponent && (_jsx(SplitItem, { isFilled: true, "data-ouia-component-id": "ConditionalFilter", children: getActiveComponent(activeItem) }))] })) }))] }));
};
export default ConditionalFilter;
//# sourceMappingURL=ConditionalFilter.js.map