var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useEffect, useRef, useState } from 'react';
import classNames from 'classnames';
import { Button } from '@patternfly/react-core/dist/dynamic/components/Button';
import { Checkbox } from '@patternfly/react-core/dist/dynamic/components/Checkbox';
import { Menu } from '@patternfly/react-core/dist/dynamic/components/Menu';
import { MenuContent, MenuGroup, MenuItem, MenuList } from '@patternfly/react-core/dist/dynamic/components/Menu';
import { MenuToggle } from '@patternfly/react-core/dist/dynamic/components/MenuToggle';
import { Popper } from '@patternfly/react-core/dist/dynamic/helpers/Popper/Popper';
import { Radio } from '@patternfly/react-core/dist/dynamic/components/Radio';
import { TextInputGroup, TextInputGroupMain, TextInputGroupUtilities } from '@patternfly/react-core/dist/dynamic/components/TextInputGroup';
import { TreeView } from '@patternfly/react-core/dist/dynamic/components/TreeView';
import { TimesIcon } from '@patternfly/react-icons/dist/dynamic/icons/times-icon';
import { calculateSelected, convertTreeItem, getGroupMenuItems, getMenuItems, isButtonItem, isCheckboxItem, isChecked, isRadioItem, isTreeViewItem, mapTree, onTreeCheck, } from './groupFilterConstants';
import GroupType from './groupType';
import '../ConditionalFilter/group-filter.css';
var GroupFilter = function (props) {
    var className = props.className, _a = props.filterBy, filterBy = _a === void 0 ? '' : _a, _b = props.groups, groups = _b === void 0 ? [] : _b, _c = props.items, items = _c === void 0 ? [] : _c, isFilterable = props.isFilterable, onChange = props.onChange, onShowMore = props.onShowMore, placeholder = props.placeholder, selected = props.selected, showMoreTitle = props.showMoreTitle, showMoreOptions = props.showMoreOptions, isDisabled = props.isDisabled, onFilter = props.onFilter;
    var _d = useState(''), searchString = _d[0], setSearchString = _d[1];
    var _f = useState(false), isOpen = _f[0], setIsOpen = _f[1];
    var toggleRef = useRef(null);
    var containerRef = useRef(null);
    var menuRef = useRef(null);
    var inputRef = useRef(null);
    useEffect(function () {
        setSearchString(filterBy);
    }, [filterBy]);
    var handleMenuKeys = function (event) {
        var _a, _b, _c;
        if (!isOpen) {
            return;
        }
        if (((_a = menuRef.current) === null || _a === void 0 ? void 0 : _a.contains(event.target)) || ((_b = toggleRef.current) === null || _b === void 0 ? void 0 : _b.contains(event.target))) {
            if (event.key === 'Escape' || event.key === 'Enter') {
                setIsOpen(!isOpen);
                (_c = toggleRef.current) === null || _c === void 0 ? void 0 : _c.focus();
            }
        }
    };
    var handleClickOutside = function (event) {
        var _a, _b, _c;
        if (!isOpen)
            return;
        var clickedInsideInput = (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.contains(event.target);
        var clickedInsideMenu = (_b = menuRef.current) === null || _b === void 0 ? void 0 : _b.contains(event.target);
        var clickedToggle = (_c = toggleRef.current) === null || _c === void 0 ? void 0 : _c.contains(event.target);
        if (clickedInsideInput || clickedInsideMenu || clickedToggle)
            return;
        setIsOpen(false);
    };
    useEffect(function () {
        window.addEventListener('keydown', handleMenuKeys);
        window.addEventListener('click', handleClickOutside);
        return function () {
            window.removeEventListener('keydown', handleMenuKeys);
            window.removeEventListener('click', handleClickOutside);
        };
    }, [isOpen, menuRef]);
    var onToggleClick = function () {
        setIsOpen(!isOpen);
    };
    var menuItems = getMenuItems((items === null || items === void 0 ? void 0 : items.map(function (item) { return (item.type === GroupType.treeView ? convertTreeItem(item) : item); })) || [], onChange, calculateSelected(selected || {}));
    var groupMenuItems = getGroupMenuItems(groups, onChange, calculateSelected(selected || {}));
    var renderItem = function (_a, key, type, groupKey) {
        var groupSelectable = _a.groupSelectable, item = __rest(_a, ["groupSelectable"]);
        if (groupKey === void 0) { groupKey = ''; }
        return (_jsx(MenuItem, { itemId: key, className: item === null || item === void 0 ? void 0 : item.className, onClick: isCheckboxItem(type, item)
                ? function (e) {
                    var _a;
                    (_a = item.onClick) === null || _a === void 0 ? void 0 : _a.call(item, e);
                    e.preventDefault();
                }
                : undefined, children: isTreeViewItem(type, item) ? (_jsx(TreeView, { data: [mapTree(item, groupKey, selected || {})], onCheck: function (e, value) { return onTreeCheck(e, value, [item]); }, hasCheckboxes: true })) : isCheckboxItem(type, item) ? (_jsx(Checkbox, __assign({}, item, { label: item === null || item === void 0 ? void 0 : item.label, isChecked: (item === null || item === void 0 ? void 0 : item.isChecked) || isChecked(groupKey, (item === null || item === void 0 ? void 0 : item.value) || key, item === null || item === void 0 ? void 0 : item.id, item === null || item === void 0 ? void 0 : item.tagValue, selected || {}) || false, onChange: item.onChange, onClick: item.onClick
                    ? function (e) {
                        var _a;
                        (_a = item.onClick) === null || _a === void 0 ? void 0 : _a.call(item, e);
                        e.stopPropagation();
                    }
                    : undefined, name: (item === null || item === void 0 ? void 0 : item.name) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key), id: (item === null || item === void 0 ? void 0 : item.id) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key) }))) : isRadioItem(type, item) ? (_jsx(Radio, __assign({}, item, { isChecked: (item === null || item === void 0 ? void 0 : item.isChecked) || isChecked(groupKey, item.value, item === null || item === void 0 ? void 0 : item.id, item === null || item === void 0 ? void 0 : item.tagValue, selected || {}) || false, onChange: item.onChange, value: (item === null || item === void 0 ? void 0 : item.value) || key, name: (item === null || item === void 0 ? void 0 : item.name) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key), label: (item === null || item === void 0 ? void 0 : item.label) || '', id: (item === null || item === void 0 ? void 0 : item.id) || (item === null || item === void 0 ? void 0 : item.value) || "".concat(groupKey, "-").concat(key) }))) : isButtonItem(type, item) ? (_jsx(Button, { id: item.id, className: classNames('pf-v6-c-select__option-button', item.className), variant: item.variant, onClick: item.onClick, children: item.label })) : ((item === null || item === void 0 ? void 0 : item.label) || '') }, "".concat(item.value, "-").concat(key, "-item")));
    };
    var renderItems = function (items, type, groupKey) {
        if (groupKey === void 0) { groupKey = ''; }
        return items.map(function (item, key) {
            return (type || item.type) === GroupType.treeView ? (_jsx("div", { className: "ins-c-tree-view", children: renderItem(item, key, type, groupKey) }, "".concat(item.value, "-").concat(key, "-item"))) : (renderItem(item, key, type, groupKey));
        });
    };
    var hasFocus = document.activeElement === inputRef.current || document.activeElement === toggleRef.current;
    var searchDirty = hasFocus && (searchString === null || searchString === void 0 ? void 0 : searchString.length) > 0;
    var setFilter = function (value) {
        setSearchString(value);
        onFilter === null || onFilter === void 0 ? void 0 : onFilter(value);
    };
    return (_jsx("div", { ref: containerRef, children: _jsx(Popper, { appendTo: containerRef.current, trigger: _jsx(MenuToggle, { "aria-label": "Group filter", innerRef: toggleRef, onClick: onToggleClick, isExpanded: isOpen, className: classNames('ins-c-group-menu-toggle', className, {
                    'pf-v6-u-p-0': isFilterable,
                }), isDisabled: isDisabled, variant: isFilterable || onFilter ? 'typeahead' : 'default', children: isFilterable || onFilter ? (_jsxs(TextInputGroup, { isDisabled: isDisabled, isPlain: true, children: [_jsx(TextInputGroupMain, { autoComplete: "off", innerRef: inputRef, onClick: onToggleClick, onChange: function (_e, value) {
                                setFilter(value);
                            }, "aria-label": "input with dropdown and clear button", placeholder: placeholder, value: searchString, type: "text" }), _jsx(TextInputGroupUtilities, { children: searchDirty && (_jsx(Button, { icon: _jsx(TimesIcon, { "aria-hidden": true }), variant: "plain", onClick: function () {
                                    setFilter('');
                                    setIsOpen(false);
                                }, "aria-label": "Clear input value" })) })] })) : (placeholder) }), popper: _jsx(Menu, { ref: menuRef, className: classNames('ins-c-menu__scrollable', className, { 'pf-m-expanded': isOpen }), children: _jsx(MenuContent, { children: _jsxs(MenuList, { "aria-label": "Group filter", children: [menuItems.length > 0 && _jsx(MenuGroup, { children: renderItems(menuItems) }), groupMenuItems.map(function (group, groupKey) { return (_jsx(MenuGroup, { label: !group.groupSelectable && typeof group.label === 'string' ? group.label : undefined, children: group.items && renderItems(group.items, group.type, group.value) }, "".concat(group.label, "-").concat(groupKey, "-group"))); }), onShowMore ? (_jsx(MenuItem, __assign({ itemId: "loader", className: "ins-c-menu__show--more" }, showMoreOptions, { onClick: function (e) { return onShowMore(e); }, children: showMoreTitle }))) : (_jsx("span", { hidden: true, value: "" }))] }) }) }), isVisible: isOpen }) }));
};
export default GroupFilter;
//# sourceMappingURL=GroupFilter.js.map