import React from 'react';
export type Tag = {
    key: string;
    value: string;
};
type TagGroup = {
    count: number;
    tag: Tag;
};
export type FilterHookGroupItem = {
    tagKey: string;
    tagValue: string;
    meta?: {
        tag: Tag;
    };
};
type Group = {
    isSelected: boolean;
    group: Record<string, unknown>;
    value?: string;
    item?: FilterHookGroupItem;
};
export type GroupValue = {
    [key: string]: Group;
};
type ConstructValuesItem = {
    key: string;
    tagKey: string;
    value?: string;
    name: string;
    group: Record<string, unknown>;
};
export type AllTag = {
    name: React.ReactNode;
    type?: 'checkbox';
    tags: TagGroup[];
};
export declare function constructValues(groupValue: GroupValue, groupKey: string): ConstructValuesItem[];
interface MapGroupsItem {
    type: 'tags';
    key: string;
    category: any;
    [key: string]: ConstructValuesItem[] | 'tags' | string | any;
}
export declare function mapGroups(currSelection: {
    [key: string]: GroupValue;
}, valuesKey?: string): MapGroupsItem[];
export declare function constructGroups(allTags: AllTag[], item?: string): {
    label: React.ReactNode;
    value: React.ReactNode;
    type: "checkbox";
    items: {
        className: string;
        label: import("react/jsx-runtime").JSX.Element;
        meta: {
            count: number;
            tag: {
                key: string;
                value: string;
            };
        };
        id: string;
        tagKey: string;
        value: string;
        tagValue: string;
    }[];
}[];
export {};
