import React from 'react';
import { DropdownProps, MenuToggleProps } from '@patternfly/react-core';
import { DownloadButtonProps } from '../DownloadButton';
type ActionObject = {
    key?: string;
    label: React.ReactNode;
    value?: number | string;
    onClick?: (event: MouseEvent | React.MouseEvent<any, MouseEvent> | React.KeyboardEvent<Element>, action: ActionObject, key: string | number) => void;
    props?: {
        [key: string]: any;
        className?: string;
    };
};
export type ActionsType = React.ReactNode | ActionObject;
export interface ActionsProps {
    actions?: ActionsType[];
    onSelect?: DropdownProps['onSelect'];
    overflowActions?: ActionsType[];
    dropdownProps?: DropdownProps;
    kebabToggleProps?: MenuToggleProps;
    exportConfig?: DownloadButtonProps;
}
export declare const overflowActionsMapper: (action: ActionsType, key: string | number) => import("react/jsx-runtime").JSX.Element;
export declare const actionPropsGenerator: (action: ActionsType, key: string | number) => {
    onClick: ((e: MouseEvent | React.MouseEvent<any, MouseEvent> | React.KeyboardEvent<Element>) => any) | undefined;
    component: any;
    children: React.ReactNode;
    className?: string;
};
declare const Actions: React.FunctionComponent<ActionsProps>;
export default Actions;
